Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c	(revision 502)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c	(revision 503)
@@ -1031,411 +456,4 @@
 
 
-/*
- * Find account for incoming request.
- */
-PJ_DEF(pjsua_acc_id) pjsua_acc_find_for_incoming(pjsip_rx_data *rdata)
-{
-    pjsip_uri *uri;
-    pjsip_sip_uri *sip_uri;
-    unsigned acc_index;
-
-    uri = rdata->msg_info.to->uri;
-
-    /* Just return default account if To URI is not SIP: */
-    if (!PJSIP_URI_SCHEME_IS_SIP(uri) && 
-	!PJSIP_URI_SCHEME_IS_SIPS(uri)) 
-    {
-	return pjsua.default_acc;
-    }
-
-
-    sip_uri = (pjsip_sip_uri*)pjsip_uri_get_uri(uri);
-
-    /* Find account which has matching username and domain. */
-    for (acc_index=0; acc_index < pjsua.config.acc_cnt; ++acc_index) {
-
-	pjsua_acc *acc = &pjsua.acc[acc_index];
-
-	if (pj_stricmp(&acc->user_part, &sip_uri->user)==0 &&
-	    pj_stricmp(&acc->host_part, &sip_uri->host)==0) 
-	{
-	    /* Match ! */
-	    return acc_index;
-	}
-    }
-
-    /* No matching, try match domain part only. */
-    for (acc_index=0; acc_index < pjsua.config.acc_cnt; ++acc_index) {
-
-	pjsua_acc *acc = &pjsua.acc[acc_index];
-
-	if (pj_stricmp(&acc->host_part, &sip_uri->host)==0) {
-	    /* Match ! */
-	    return acc_index;
-	}
-    }
-
-    /* Still no match, use default account */
-    return pjsua.default_acc;
-}
-
-
-/*
- * Find account for outgoing request.
- */
-PJ_DEF(pjsua_acc_id) pjsua_acc_find_for_outgoing(const pj_str_t *str_url)
-{
-    pj_str_t tmp;
-    pjsip_uri *uri;
-    pjsip_sip_uri *sip_uri;
-    unsigned i;
-
-    pj_strdup_with_null(pjsua.pool, &tmp, str_url);
-
-    uri = pjsip_parse_uri(pjsua.pool, tmp.ptr, tmp.slen, 0);
-    if (!uri)
-	return pjsua.config.acc_cnt-1;
-
-    if (!PJSIP_URI_SCHEME_IS_SIP(uri) && 
-	!PJSIP_URI_SCHEME_IS_SIPS(uri)) 
-    {
-	/* Return the first account with proxy */
-	for (i=0; i<PJ_ARRAY_SIZE(pjsua.acc); ++i) {
-	    if (!pjsua.acc[i].valid)
-		continue;
-	    if (pjsua.config.acc_config[i].proxy.slen)
-		break;
-	}
-
-	if (i != PJ_ARRAY_SIZE(pjsua.acc))
-	    return i;
-
-	/* Not found, use default account */
-	return pjsua.default_acc;
-    }
-
-    sip_uri = pjsip_uri_get_uri(uri);
-
-    /* Find matching domain */
-    for (i=0; i<PJ_ARRAY_SIZE(pjsua.acc); ++i) {
-	if (!pjsua.acc[i].valid)
-	    continue;
-	if (pj_stricmp(&pjsua.acc[i].host_part, &sip_uri->host)==0)
-	    break;
-    }
-
-    if (i != PJ_ARRAY_SIZE(pjsua.acc))
-	return i;
-
-    /* Just use default account */
-    return pjsua.default_acc;
-}
-
-
-/*
- * Init account
- */
-static pj_status_t init_acc(unsigned acc_index)
-{
-    pjsua_acc_config *acc_cfg = &pjsua.config.acc_config[acc_index];
-    pjsua_acc *acc = &pjsua.acc[acc_index];
-    pjsip_uri *uri;
-    pjsip_sip_uri *sip_uri;
-
-    /* Need to parse local_uri to get the elements: */
-
-    uri = pjsip_parse_uri(pjsua.pool, acc_cfg->id.ptr,
-			  acc_cfg->id.slen, 0);
-    if (uri == NULL) {
-	pjsua_perror(THIS_FILE, "Invalid local URI", 
-		     PJSIP_EINVALIDURI);
-	return PJSIP_EINVALIDURI;
-    }
-
-    /* Local URI MUST be a SIP or SIPS: */
-
-    if (!PJSIP_URI_SCHEME_IS_SIP(uri) && 
-	!PJSIP_URI_SCHEME_IS_SIPS(uri)) 
-    {
-	pjsua_perror(THIS_FILE, "Invalid local URI", 
-		     PJSIP_EINVALIDSCHEME);
-	return PJSIP_EINVALIDSCHEME;
-    }
-
-
-    /* Get the SIP URI object: */
-
-    sip_uri = (pjsip_sip_uri*) pjsip_uri_get_uri(uri);
-
-    acc->user_part = sip_uri->user;
-    acc->host_part = sip_uri->host;
-
-    /* Build Contact header */
-
-    if (acc_cfg->contact.slen == 0)  {
-	char contact[128];
-	const char *addr;
-	int port;
-	int len;
-
-	addr = pjsua.config.sip_host.ptr;
-	port = pjsua.config.sip_port;
-
-	/* The local Contact is the username@ip-addr, where
-	 *  - username is taken from the local URI,
-	 *  - ip-addr in UDP transport's address name (which may have been
-	 *    resolved from STUN.
-	 */
-	
-	/* Build temporary contact string. */
-
-	if (sip_uri->user.slen) {
-
-	    /* With the user part. */
-	    len = pj_ansi_snprintf(contact, sizeof(contact),
-			      "<sip:%.*s@%s:%d>",
-			      (int)sip_uri->user.slen,
-			      sip_uri->user.ptr,
-			      addr, port);
-	} else {
-
-	    /* Without user part */
-
-	    len = pj_ansi_snprintf(contact, sizeof(contact),
-			      "<sip:%s:%d>",
-			      addr, port);
-	}
-
-	if (len < 1 || len >= sizeof(contact)) {
-	    pjsua_perror(THIS_FILE, "Invalid Contact", PJSIP_EURITOOLONG);
-	    return PJSIP_EURITOOLONG;
-	}
-
-	/* Duplicate Contact uri. */
-
-	pj_strdup2(pjsua.pool, &acc_cfg->contact, contact);
-
-    }
-
-
-    /* Build route-set for this account */
-    if (pjsua.config.outbound_proxy.slen) {
-	pj_str_t hname = { "Route", 5};
-	pjsip_route_hdr *r;
-	pj_str_t tmp;
-
-	pj_strdup_with_null(pjsua.pool, &tmp, &pjsua.config.outbound_proxy);
-	r = pjsip_parse_hdr(pjsua.pool, &hname, tmp.ptr, tmp.slen, NULL);
-	pj_list_push_back(&acc->route_set, r);
-    }
-
-    if (acc_cfg->proxy.slen) {
-	pj_str_t hname = { "Route", 5};
-	pjsip_route_hdr *r;
-	pj_str_t tmp;
-
-	pj_strdup_with_null(pjsua.pool, &tmp, &acc_cfg->proxy);
-	r = pjsip_parse_hdr(pjsua.pool, &hname, tmp.ptr, tmp.slen, NULL);
-	pj_list_push_back(&acc->route_set, r);
-    }
-
-    /* Mark account as valid */
-    pjsua.acc[acc_index].valid = PJ_TRUE;
-
-
-    return PJ_SUCCESS;
-}
-
-/*
- * Add a new account.
- */
-PJ_DEF(pj_status_t) pjsua_acc_add( const pjsua_acc_config *cfg,
-				   pjsua_acc_id *acc_index)
-{
-    unsigned index;
-    pj_status_t status;
-
-    PJ_ASSERT_RETURN(pjsua.config.acc_cnt < 
-			PJ_ARRAY_SIZE(pjsua.config.acc_config),
-		     PJ_ETOOMANY);
-
-    /* Find empty account index. */
-    for (index=0; index < PJ_ARRAY_SIZE(pjsua.acc); ++index) {
-	if (pjsua.acc[index].valid == PJ_FALSE)
-	    break;
-    }
-
-    /* Expect to find a slot */
-    PJ_ASSERT_RETURN(index < PJ_ARRAY_SIZE(pjsua.acc), PJ_EBUG);
-
-    copy_acc_config(pjsua.pool, &pjsua.config.acc_config[index], cfg);
-    
-    status = init_acc(index);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Error adding account", status);
-	return status;
-    }
-
-    if (acc_index)
-	*acc_index = index;
-
-    pjsua.config.acc_cnt++;
-
-    return PJ_SUCCESS;
-}
-
-
-/*
- * Delete account.
- */
-PJ_DEF(pj_status_t) pjsua_acc_del(pjsua_acc_id acc_index)
-{
-    PJ_ASSERT_RETURN(acc_index < (int)pjsua.config.acc_cnt, 
-		     PJ_EINVAL);
-    PJ_ASSERT_RETURN(pjsua.acc[acc_index].valid, PJ_EINVALIDOP);
-
-    /* Delete registration */
-    if (pjsua.acc[acc_index].regc != NULL) 
-	pjsua_acc_set_registration(acc_index, PJ_FALSE);
-
-    /* Invalidate */
-    pjsua.acc[acc_index].valid = PJ_FALSE;
-
-    return PJ_SUCCESS;
-}
-
-
-/*
- * Start pjsua stack.
- * This will start the registration process, if registration is configured.
- */
-PJ_DEF(pj_status_t) pjsua_start(void)
-{
-    int i;  /* Must be signed */
-    unsigned count;
-    pj_status_t status = PJ_SUCCESS;
-
-
-    /* Add UDP transport: */
-    if (pjsua.sip_sock > 0) {
-
-	/* Init the published name for the transport.
-         * Depending whether STUN is used, this may be the STUN mapped
-	 * address, or socket's bound address.
-	 */
-	pjsip_host_port addr_name;
-
-	addr_name.host = pjsua.config.sip_host;
-	addr_name.port = pjsua.config.sip_port;
-
-	/* Create UDP transport from previously created UDP socket: */
-
-	status = pjsip_udp_transport_attach( pjsua.endpt, pjsua.sip_sock,
-					     &addr_name, 1, 
-					     NULL);
-	if (status != PJ_SUCCESS) {
-	    pjsua_perror(THIS_FILE, "Unable to start UDP transport", 
-			 status);
-	    goto on_error;
-	}
-    }
-
-    /* Initialize all unused accounts with default id and contact.
-     */
-    {
-	char buf[80];
-	pj_str_t tmp, id;
-
-	tmp.ptr = buf;
-	tmp.slen = pj_ansi_sprintf(tmp.ptr, "Local <sip:%s:%d>", 
-				   pjsua.config.sip_host.ptr,
-				   pjsua.config.sip_port);
-	pj_strdup_with_null( pjsua.pool, &id, &tmp);
-
-	for (i=pjsua.config.acc_cnt; i<PJ_ARRAY_SIZE(pjsua.config.acc_config);
-	     ++i)
-	{
-	    pjsua_acc_config *acc_cfg = 
-		&pjsua.config.acc_config[pjsua.config.acc_cnt];
-
-	    acc_cfg->id = id;
-	    acc_cfg->contact = id;
-	}
-    }
-    
-
-    /* Add another account as the last one. 
-     * This account corresponds to local endpoint, and is user-less.
-     * This is also the default account.
-     */
-    if (pjsua.config.acc_cnt < PJ_ARRAY_SIZE(pjsua.config.acc_config)) {
-	pjsua.default_acc = pjsua.config.acc_cnt;
-	pjsua.acc[pjsua.default_acc].auto_gen = 1;
-	pjsua.config.acc_cnt++;
-    }
-
-
-    /* Initialize accounts: */
-    for (i=0; i<(int)pjsua.config.acc_cnt; ++i) {
-	status = init_acc(i);
-	if (status != PJ_SUCCESS) {
-	    pjsua_perror(THIS_FILE, "Error initializing account", status);
-	    goto on_error;
-	}
-    }
-
-
-    /* Create worker thread(s), if required: */
-
-    for (i=0; i<(int)pjsua.config.thread_cnt; ++i) {
-	status = pj_thread_create( pjsua.pool, "pjsua", &pjsua_poll,
-				   NULL, 0, 0, &pjsua.threads[i]);
-	if (status != PJ_SUCCESS) {
-	    pjsua.quit_flag = 1;
-	    for (--i; i>=0; --i) {
-		pj_thread_join(pjsua.threads[i]);
-		pj_thread_destroy(pjsua.threads[i]);
-	    }
-	    goto on_error;
-	}
-    }
-
-    /* Start registration: */
-
-    /* Create client registration session: */
-    for (i=0; i<(int)pjsua.config.acc_cnt; ++i) {
-	status = pjsua_regc_init(i);
-	if (status != PJ_SUCCESS)
-	    goto on_error;
-
-	/* Perform registration, if required. */
-	if (pjsua.acc[i].regc) {
-	    pjsua_acc_set_registration(i, PJ_TRUE);
-	}
-    }
-
-
-    /* Re-init buddies */
-    count = pjsua.config.buddy_cnt;
-    pjsua.config.buddy_cnt = 0;
-    for (i=0; i<(int)count; ++i) {
-	pj_str_t uri = pjsua.config.buddy_uri[i];
-	pjsua_buddy_add(&uri, NULL);
-    }
-
-
-    /* Refresh presence */
-    pjsua_pres_refresh();
-
-
-    PJ_LOG(3,(THIS_FILE, "PJSUA version %s started", PJ_VERSION));
-    return PJ_SUCCESS;
-
-on_error:
-    pjsua_destroy();
-    return status;
-}
-
-
 /* Sleep with polling */
 static void busy_sleep(unsigned msec)
@@ -1448,295 +466,30 @@
 
     do {
-	pjsua_poll(NULL);
+	while (pjsua_handle_events(10) > 0)
+	    ;
 	pj_gettimeofday(&now);
     } while (PJ_TIME_VAL_LT(now, timeout));
 }
 
-/**
- * Get maxinum number of conference ports.
- */
-PJ_DEF(unsigned) pjsua_conf_max_ports(void)
-{
-    return pjsua.config.conf_ports;
-}
-
-
-/**
- * Enum all conference port ID.
- */
-PJ_DEF(pj_status_t) pjsua_conf_enum_port_ids( pjsua_conf_port_id id[],
-					      unsigned *count)
-{
-    return pjmedia_conf_enum_ports( pjsua.mconf, (unsigned*)id, count);
-}
-
-
-
-/**
- * Get information about the specified conference port
- */
-PJ_DEF(pj_status_t) pjsua_conf_get_port_info( pjsua_conf_port_id id,
-					      pjsua_conf_port_info *info)
-{
-    pjmedia_conf_port_info cinfo;
-    unsigned i, count;
-    pj_status_t status;
-
-    status = pjmedia_conf_get_port_info( pjsua.mconf, id, &cinfo);
-    if (status != PJ_SUCCESS)
-	return status;
-
-    pj_memset(info, 0, sizeof(*info));
-    info->slot_id = id;
-    info->name = cinfo.name;
-    info->clock_rate = cinfo.clock_rate;
-    info->channel_count = cinfo.channel_count;
-    info->samples_per_frame = cinfo.samples_per_frame;
-    info->bits_per_sample = cinfo.bits_per_sample;
-
-    /* Build array of listeners */
-    count = pjsua.config.conf_ports;
-    for (i=0; i<count; ++i) {
-	if (cinfo.listener[i]) {
-	    info->listeners[info->listener_cnt++] = i;
+/*
+ * Destroy pjsua.
+ */
+PJ_DEF(pj_status_t) pjsua_destroy(void)
+{
+    int i;  /* Must be signed */
+
+    /* Signal threads to quit: */
+    pjsua_var.thread_quit_flag = 1;
+
+    /* Wait worker threads to quit: */
+    for (i=0; i<(int)pjsua_var.ua_cfg.thread_cnt; ++i) {
+	if (pjsua_var.thread[i]) {
+	    pj_thread_join(pjsua_var.thread[i]);
+	    pj_thread_destroy(pjsua_var.thread[i]);
+	    pjsua_var.thread[i] = NULL;
 	}
     }
-
-    return PJ_SUCCESS;
-}
-
-
-/**
- * Connect conference port.
- */
-PJ_DEF(pj_status_t) pjsua_conf_connect( pjsua_conf_port_id src_port,
-					pjsua_conf_port_id dst_port)
-{
-    return pjmedia_conf_connect_port(pjsua.mconf, src_port, dst_port, 0);
-}
-
-
-/**
- * Connect conference port connection.
- */
-PJ_DEF(pj_status_t) pjsua_conf_disconnect( pjsua_conf_port_id src_port,
-					   pjsua_conf_port_id dst_port)
-{
-    return pjmedia_conf_disconnect_port(pjsua.mconf, src_port, dst_port);
-}
-
-
-
-/**
- * Create a file player.
- */
-PJ_DEF(pj_status_t) pjsua_player_create( const pj_str_t *filename,
-					 pjsua_player_id *id)
-{
-    unsigned slot;
-    char path[128];
-    pjmedia_port *port;
-    pj_status_t status;
-
-    if (pjsua.player_cnt >= PJ_ARRAY_SIZE(pjsua.player))
-	return PJ_ETOOMANY;
-
-    pj_memcpy(path, filename->ptr, filename->slen);
-    path[filename->slen] = '\0';
-    status = pjmedia_wav_player_port_create(pjsua.pool, path,
-					    pjsua.samples_per_frame *
-					       1000 / pjsua.clock_rate,
-					    0, 0, NULL,
-					    &port);
-    if (status != PJ_SUCCESS)
-	return status;
-
-    status = pjmedia_conf_add_port(pjsua.mconf, pjsua.pool, 
-				   port, filename, &slot);
-    if (status != PJ_SUCCESS) {
-	pjmedia_port_destroy(port);
-	return status;
-    }
-
-    pjsua.player[pjsua.player_cnt].port = port;
-    pjsua.player[pjsua.player_cnt].slot = slot;
-
-    if (id)
-	*id = pjsua.player_cnt;
-
-    ++pjsua.player_cnt;
-
-    return PJ_SUCCESS;
-}
-
-
-/**
- * Get conference port associated with player.
- */
-PJ_DEF(pjsua_conf_port_id) pjsua_player_get_conf_port(pjsua_player_id id)
-{
-    PJ_ASSERT_RETURN(id>=0 && id < PJ_ARRAY_SIZE(pjsua.player), PJ_EINVAL);
-    return pjsua.player[id].slot;
-}
-
-
-/**
- * Re-wind playback.
- */
-PJ_DEF(pj_status_t) pjsua_player_set_pos(pjsua_player_id id,
-					 pj_uint32_t samples)
-{
-    PJ_ASSERT_RETURN(id>=0 && id < PJ_ARRAY_SIZE(pjsua.player), PJ_EINVAL);
-    PJ_ASSERT_RETURN(pjsua.player[id].port != NULL, PJ_EINVALIDOP);
-
-    return pjmedia_wav_player_port_set_pos(pjsua.player[id].port, samples);
-}
-
-
-/**
- * Get conference port associated with player.
- */
-PJ_DEF(pj_status_t) pjsua_player_destroy(pjsua_player_id id)
-{
-    PJ_ASSERT_RETURN(id>=0 && id < PJ_ARRAY_SIZE(pjsua.player), PJ_EINVAL);
-
-    if (pjsua.player[id].port) {
-	pjmedia_port_destroy(pjsua.player[id].port);
-	pjsua.player[id].port = NULL;
-	pjsua.player[id].slot = 0xFFFF;
-	pjsua.player_cnt--;
-    }
-
-    return PJ_SUCCESS;
-}
-
-
-/**
- * Create a file recorder.
- */
-PJ_DEF(pj_status_t) pjsua_recorder_create( const pj_str_t *filename,
-					   pjsua_recorder_id *id)
-{
-    unsigned slot;
-    char path[128];
-    pjmedia_port *port;
-    pj_status_t status;
-
-    if (pjsua.recorder_cnt >= PJ_ARRAY_SIZE(pjsua.recorder))
-	return PJ_ETOOMANY;
-
-    pj_memcpy(path, filename->ptr, filename->slen);
-    path[filename->slen] = '\0';
-    status = pjmedia_wav_writer_port_create(pjsua.pool, path,
-					    pjsua.clock_rate, 1,
-					    pjsua.samples_per_frame,
-					    16, 0, 0, NULL,
-					    &port);
-    if (status != PJ_SUCCESS)
-	return status;
-
-    status = pjmedia_conf_add_port(pjsua.mconf, pjsua.pool, 
-				   port, filename, &slot);
-    if (status != PJ_SUCCESS) {
-	pjmedia_port_destroy(port);
-	return status;
-    }
-
-    pjsua.recorder[pjsua.recorder_cnt].port = port;
-    pjsua.recorder[pjsua.recorder_cnt].slot = slot;
-
-    if (*id)
-	*id = pjsua.recorder_cnt;
-
-    ++pjsua.recorder_cnt;
-
-    return PJ_SUCCESS;
-}
-
-
-/**
- * Get conference port associated with recorder.
- */
-PJ_DEF(pjsua_conf_port_id) pjsua_recorder_get_conf_port(pjsua_recorder_id id)
-{
-    PJ_ASSERT_RETURN(id>=0 && id < PJ_ARRAY_SIZE(pjsua.recorder), PJ_EINVAL);
-    return pjsua.recorder[id].slot;
-}
-
-
-/**
- * Destroy recorder (will complete recording).
- */
-PJ_DEF(pj_status_t) pjsua_recorder_destroy(pjsua_recorder_id id)
-{
-    PJ_ASSERT_RETURN(id>=0 && id < PJ_ARRAY_SIZE(pjsua.recorder), PJ_EINVAL);
-
-    if (pjsua.recorder[id].port) {
-	pjmedia_port_destroy(pjsua.recorder[id].port);
-	pjsua.recorder[id].port = NULL;
-	pjsua.recorder[id].slot = 0xFFFF;
-	pjsua.recorder_cnt--;
-    }
-
-    return PJ_SUCCESS;
-}
-
-/**
- * Enum sound devices.
- */
-PJ_DEF(pj_status_t) pjsua_enum_snd_devices( unsigned *count,
-					    pjmedia_snd_dev_info info[])
-{
-    int i, dev_count;
-
-    dev_count = pjmedia_snd_get_dev_count();
-    if (dev_count > (int)*count)
-	dev_count = *count;
-
-    for (i=0; i<dev_count; ++i) {
-	const pjmedia_snd_dev_info *dev_info;
-	dev_info = pjmedia_snd_get_dev_info(i);
-	pj_memcpy(&info[i], dev_info, sizeof(pjmedia_snd_dev_info));
-    }
-
-    *count = dev_count;
-    return PJ_SUCCESS;
-}
-
-
-/**
- * Select or change sound device.
- */
-PJ_DEF(pj_status_t) pjsua_set_snd_dev( int snd_capture_id,
-				       int snd_player_id)
-{
-    pjsua.config.snd_capture_id = snd_capture_id;
-    pjsua.config.snd_player_id = snd_player_id;
-    return PJ_SUCCESS;
-}
-
-
-/*
- * Destroy pjsua.
- */
-PJ_DEF(pj_status_t) pjsua_destroy(void)
-{
-    int i;  /* Must be signed */
-
-    /* Signal threads to quit: */
-    pjsua.quit_flag = 1;
-
-    /* Wait worker threads to quit: */
-    for (i=0; i<(int)pjsua.config.thread_cnt; ++i) {
-	
-	if (pjsua.threads[i]) {
-	    pj_thread_join(pjsua.threads[i]);
-	    pj_thread_destroy(pjsua.threads[i]);
-	    pjsua.threads[i] = NULL;
-	}
-    }
-
     
-    if (pjsua.endpt) {
+    if (pjsua_var.endpt) {
 	/* Terminate all calls. */
 	pjsua_call_hangup_all();
@@ -1746,6 +499,9 @@
 
 	/* Unregister, if required: */
-	for (i=0; i<(int)pjsua.config.acc_cnt; ++i) {
-	    if (pjsua.acc[i].regc) {
+	for (i=0; i<(int)PJ_ARRAY_SIZE(pjsua_var.acc); ++i) {
+	    if (!pjsua_var.acc[i].valid)
+		continue;
+
+	    if (pjsua_var.acc[i].regc) {
 		pjsua_acc_set_registration(i, PJ_FALSE);
 	    }
@@ -1757,88 +513,288 @@
     }
 
-    /* If we have master port, destroying master port will recursively
-     * destroy conference bridge, otherwise must destroy it manually. 
+    /* Destroy media */
+    pjsua_media_subsys_destroy();
+
+    /* Destroy endpoint. */
+    if (pjsua_var.endpt) {
+	pjsip_endpt_destroy(pjsua_var.endpt);
+	pjsua_var.endpt = NULL;
+    }
+
+    /* Destroy mutex */
+    if (pjsua_var.mutex) {
+	pj_mutex_destroy(pjsua_var.mutex);
+	pjsua_var.mutex = NULL;
+    }
+
+    /* Destroy pool and pool factory. */
+    if (pjsua_var.pool) {
+	pj_pool_release(pjsua_var.pool);
+	pjsua_var.pool = NULL;
+	pj_caching_pool_destroy(&pjsua_var.cp);
+    }
+
+
+    PJ_LOG(4,(THIS_FILE, "PJSUA destroyed..."));
+
+    /* End logging */
+    if (pjsua_var.log_file) {
+	pj_file_close(pjsua_var.log_file);
+	pjsua_var.log_file = NULL;
+    }
+
+    /* Done. */
+    return PJ_SUCCESS;
+}
+
+
+/**
+ * Application is recommended to call this function after all initialization
+ * is done, so that the library can do additional checking set up
+ * additional 
+ *
+ * @return		PJ_SUCCESS on success, or the appropriate error code.
+ */
+PJ_DEF(pj_status_t) pjsua_start(void)
+{
+    pj_status_t status;
+
+    status = pjsua_call_subsys_start();
+    if (status != PJ_SUCCESS)
+	return status;
+
+    status = pjsua_media_subsys_start();
+    if (status != PJ_SUCCESS)
+	return status;
+
+    status = pjsua_pres_start();
+    if (status != PJ_SUCCESS)
+	return status;
+
+    return PJ_SUCCESS;
+}
+
+
+/**
+ * Poll pjsua for events, and if necessary block the caller thread for
+ * the specified maximum interval (in miliseconds).
+ */
+PJ_DEF(int) pjsua_handle_events(unsigned msec_timeout)
+{
+    unsigned count = 0;
+    pj_time_val tv;
+    pj_status_t status;
+
+    tv.sec = 0;
+    tv.msec = msec_timeout;
+    pj_time_val_normalize(&tv);
+
+    status = pjsip_endpt_handle_events2(pjsua_var.endpt, &tv, &count);
+
+    if (status != PJ_SUCCESS)
+	return -status;
+
+    return count;
+}
+
+
+/*
+ * Create memory pool.
+ */
+PJ_DEF(pj_pool_t*) pjsua_pool_create( const char *name, pj_size_t init_size,
+				      pj_size_t increment)
+{
+    /* Pool factory is thread safe, no need to lock */
+    return pj_pool_create(&pjsua_var.cp.factory, name, init_size, increment, 
+			  NULL);
+}
+
+
+/*
+ * Internal function to get SIP endpoint instance of pjsua, which is
+ * needed for example to register module, create transports, etc.
+ * Probably is only valid after #pjsua_init() is called.
+ */
+PJ_DEF(pjsip_endpoint*) pjsua_get_pjsip_endpt(void)
+{
+    return pjsua_var.endpt;
+}
+
+/*
+ * Internal function to get media endpoint instance.
+ * Only valid after #pjsua_init() is called.
+ */
+PJ_DEF(pjmedia_endpt*) pjsua_get_pjmedia_endpt(void)
+{
+    return pjsua_var.med_endpt;
+}
+
+
+/*****************************************************************************
+ * PJSUA SIP Transport API.
+ */
+
+/*
+ * Create and initialize SIP socket (and possibly resolve public
+ * address via STUN, depending on config).
+ */
+static pj_status_t create_sip_udp_sock(pj_in_addr bound_addr,
+				       int port,
+				       pj_bool_t use_stun,
+				       const pjsua_stun_config *stun_param,
+				       pj_sock_t *p_sock,
+				       pj_sockaddr_in *p_pub_addr)
+{
+    pjsua_stun_config stun;
+    pj_sock_t sock;
+    pj_status_t status;
+
+    PJSUA_LOCK();
+
+    status = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &sock);
+    if (status != PJ_SUCCESS) {
+	pjsua_perror(THIS_FILE, "socket() error", status);
+	goto on_return;
+    }
+
+    status = pj_sock_bind_in(sock, bound_addr.s_addr, (pj_uint16_t)port);
+    if (status != PJ_SUCCESS) {
+	pjsua_perror(THIS_FILE, "bind() error", status);
+	pj_sock_close(sock);
+	goto on_return;
+    }
+
+    /* Copy and normalize STUN param */
+    if (use_stun) {
+	pj_memcpy(&stun, stun_param, sizeof(*stun_param));
+	pjsua_normalize_stun_config(&stun);
+    } else {
+	pj_memset(&stun, 0, sizeof(pjsua_stun_config));
+    }
+
+    /* Get the published address, either by STUN or by resolving
+     * the name of local host.
      */
-    if (pjsua.master_port) {
-	pjmedia_master_port_destroy(pjsua.master_port);
-	pjsua.master_port = NULL;
+    if (stun.stun_srv1.slen) {
+	status = pj_stun_get_mapped_addr(&pjsua_var.cp.factory, 1, &sock,
+				         &stun.stun_srv1, 
+					  stun.stun_port1,
+					 &stun.stun_srv2, 
+					  stun.stun_port2,
+				          p_pub_addr);
+	if (status != PJ_SUCCESS) {
+	    pjsua_perror(THIS_FILE, "Error resolving with STUN", status);
+	    pj_sock_close(sock);
+	    goto on_return;
+	}
+
     } else {
-	if (pjsua.snd_port) {
-	    pjmedia_snd_port_destroy(pjsua.snd_port);
-	    pjsua.snd_port = NULL;
+
+	const pj_str_t *hostname = pj_gethostname();
+	struct pj_hostent he;
+
+	status = pj_gethostbyname(hostname, &he);
+	if (status != PJ_SUCCESS) {
+	    pjsua_perror(THIS_FILE, "Unable to resolve local host", status);
+	    pj_sock_close(sock);
+	    goto on_return;
 	}
-	if (pjsua.mconf) {
-	    pjmedia_conf_destroy(pjsua.mconf);
-	    pjsua.mconf = NULL;
+
+	pj_memset(p_pub_addr, 0, sizeof(pj_sockaddr_in));
+	p_pub_addr->sin_family = PJ_AF_INET;
+	p_pub_addr->sin_port = pj_htons((pj_uint16_t)port);
+	p_pub_addr->sin_addr = *(pj_in_addr*)he.h_addr;
+    }
+
+    *p_sock = sock;
+
+on_return:
+
+    PJSUA_UNLOCK();
+
+    PJ_LOG(4,(THIS_FILE, "SIP UDP socket reachable at %s:%d",
+	      pj_inet_ntoa(p_pub_addr->sin_addr),
+	      (int)pj_ntohs(p_pub_addr->sin_port)));
+
+    return status;
+}
+
+
+/*
+ * Create SIP transport.
+ */
+PJ_DEF(pj_status_t) pjsua_transport_create( pjsip_transport_type_e type,
+					    const pjsua_transport_config *cfg,
+					    pjsua_transport_id *p_id)
+{
+    pjsip_transport *tp;
+    unsigned id;
+    pj_status_t status;
+
+    PJSUA_LOCK();
+
+    /* Find empty transport slot */
+    for (id=0; id < PJ_ARRAY_SIZE(pjsua_var.tpdata); ++id) {
+	if (pjsua_var.tpdata[id].tp == NULL)
+	    break;
+    }
+
+    if (id == PJ_ARRAY_SIZE(pjsua_var.tpdata)) {
+	status = PJ_ETOOMANY;
+	pjsua_perror(THIS_FILE, "Error creating transport", status);
+	goto on_return;
+    }
+
+    /* Create the transport */
+    if (type == PJSIP_TRANSPORT_UDP) {
+
+	pjsua_transport_config config;
+	pj_sock_t sock;
+	pj_sockaddr_in pub_addr;
+	pjsip_host_port addr_name;
+
+	/* Supply default config if it's not specified */
+	if (cfg == NULL) {
+	    pjsua_transport_config_default(&config);
+	    cfg = &config;
 	}
-    }
-
-    /* Destroy file players */
-    for (i=0; i<PJ_ARRAY_SIZE(pjsua.player); ++i) {
-	if (pjsua.player[i].port) {
-	    pjmedia_port_destroy(pjsua.player[i].port);
-	    pjsua.player[i].port = NULL;
+
+	/* Create the socket and possibly resolve the address with STUN */
+	status = create_sip_udp_sock(cfg->ip_addr, cfg->port, cfg->use_stun,
+				     &cfg->stun_config, &sock, &pub_addr);
+	if (status != PJ_SUCCESS)
+	    goto on_return;
+
+	addr_name.host = pj_str(pj_inet_ntoa(pub_addr.sin_addr));
+	addr_name.port = pj_ntohs(pub_addr.sin_port);
+
+	/* Create UDP transport */
+	status = pjsip_udp_transport_attach( pjsua_var.endpt, sock,
+					     &addr_name, 1, 
+					     &tp);
+	if (status != PJ_SUCCESS) {
+	    pjsua_perror(THIS_FILE, "Error creating SIP UDP transport", 
+			 status);
+	    pj_sock_close(sock);
+	    goto on_return;
 	}
-    }
-
-
-    /* Destroy file recorders */
-    for (i=0; i<PJ_ARRAY_SIZE(pjsua.recorder); ++i) {
-	if (pjsua.recorder[i].port) {
-	    pjmedia_port_destroy(pjsua.recorder[i].port);
-	    pjsua.recorder[i].port = NULL;
-	}
-    }
-
-
-    /* Close transports */
-    for (i=0; i<(int)pjsua.config.max_calls; ++i) {
-	if (pjsua.calls[i].med_tp) {
-	    (*pjsua.calls[i].med_tp->op->destroy)(pjsua.calls[i].med_tp);
-	    pjsua.calls[i].med_tp = NULL;
-	}
-    }
-
-    /* Destroy media endpoint. */
-    if (pjsua.med_endpt) {
-
-	/* Shutdown all codecs: */
-#	if PJMEDIA_HAS_SPEEX_CODEC
-	    pjmedia_codec_speex_deinit();
-#	endif /* PJMEDIA_HAS_SPEEX_CODEC */
-
-#	if PJMEDIA_HAS_GSM_CODEC
-	    pjmedia_codec_gsm_deinit();
-#	endif /* PJMEDIA_HAS_GSM_CODEC */
-
-#	if PJMEDIA_HAS_G711_CODEC
-	    pjmedia_codec_g711_deinit();
-#	endif	/* PJMEDIA_HAS_G711_CODEC */
-
-#	if PJMEDIA_HAS_L16_CODEC
-	    pjmedia_codec_l16_deinit();
-#	endif	/* PJMEDIA_HAS_L16_CODEC */
-
-
-	pjmedia_endpt_destroy(pjsua.med_endpt);
-	pjsua.med_endpt = NULL;
-    }
-
-    /* Destroy endpoint. */
-    if (pjsua.endpt) {
-	pjsip_endpt_destroy(pjsua.endpt);
-	pjsua.endpt = NULL;
-    }
-
-    /* Destroy caching pool. */
-    pj_caching_pool_destroy(&pjsua.cp);
-
-
-    PJ_LOG(4,(THIS_FILE, "PJSUA destroyed..."));
-
-    /* End logging */
-    logging_shutdown();
-
-    /* Done. */
+
+    } else {
+	status = PJSIP_EUNSUPTRANSPORT;
+	pjsua_perror(THIS_FILE, "Error creating transport", status);
+	goto on_return;
+    }
+
+    /* Save the transport */
+    pjsua_var.tpdata[id].tp = tp;
+
+    /* Return the ID */
+    if (p_id) *p_id = id;
+
+    status = PJ_SUCCESS;
+
+on_return:
+
+    PJSUA_UNLOCK();
 
     return PJ_SUCCESS;
